/* restore accidentally deleted EGT */  
/* NOTE this just deletes the skeletal EGT record, not all child tables */
/* See script attached to https://bioticssupport.natureserve.org/a/solutions/articles/201154-restore-a-record-from-the-deleted-schema for scripts necessary to recover child tables*/

accept path char prompt 'Enter path in which to save log file, w/o last back slash): ' 
accept v_egt_id number prompt ' What is the EGT_ID of the Element you wish to Undelete?';
spool '&path\UndeleteEGTID_&v_egt_id.log'

set verify off
set echo off


Insert into biotics_user.ELEMENT_GLOBAL
   (ELEMENT_GLOBAL_ID,ELCODE_BCD,GNAME_ID,CONCEPT_REFERENCE_ID,CONCEPT_NAME_ID,INACTIVE_IND,G_PRIMARY_COMMON_NAME,ACCEPTED_BY_ECOLOGY_IND,D_CLASSIFICATION_STATUS_ID,G_CLASSIFICATION_COM,D_LANGUAGE_ID,HIGHER_CLASS_UNIT_ID,D_CIRCUMSCRIP_CONFIDENCE_ID,D_LUMP_SPLIT_POTENTIAL_ID,D_LEVEL_CHANGE_POTENTIAL_ID,RELATIONSHIP_TO_STANDARD_COM,G_RANK,G_RANK_CHANGE_DATE,G_RANK_REVIEW_DATE,ROUNDED_G_RANK,D_RANK_FORM_ID,G_RANK_RESP,ADD_TO_STD_DATE,ADD_TO_STD_AUTHORIZED_BY,ADD_TO_STD_COM,REMOVE_FROM_STD_DATE,REMOVE_FROM_STD_AUTHORIZED_BY,REMOVE_FROM_STD_COM,G_IMAGE_AVAILABLE_IND,G_IMAGE_NOTES,G_ELEMENT_INTERNAL_NOTES,REC_LAST_MOD_DATE,REC_LAST_MOD_USER,REC_CREATE_DATE,REC_CREATE_USER,ELEMENT_GLOBAL_SEQ_UID,ELEMENT_GLOBAL_OU_UID,D_MAINTAINED_BY_STATUS_ID,PENDING_IND,PARENT_ID,CLASSIFICATION_CD,G_CONFIDENCE_COM,CONCATENATED_CD,IN_PROGRESS_IND,DX_LAST_RECEIVED_DATE,DX_LAST_RECEIVED_STATUS,DX_LAST_EXCHANGE_ID)
  select ELEMENT_GLOBAL_ID,ELCODE_BCD,GNAME_ID,CONCEPT_REFERENCE_ID,CONCEPT_NAME_ID,INACTIVE_IND,G_PRIMARY_COMMON_NAME,ACCEPTED_BY_ECOLOGY_IND,D_CLASSIFICATION_STATUS_ID,G_CLASSIFICATION_COM,D_LANGUAGE_ID,HIGHER_CLASS_UNIT_ID,D_CIRCUMSCRIP_CONFIDENCE_ID,D_LUMP_SPLIT_POTENTIAL_ID,D_LEVEL_CHANGE_POTENTIAL_ID,RELATIONSHIP_TO_STANDARD_COM,G_RANK,G_RANK_CHANGE_DATE,G_RANK_REVIEW_DATE,ROUNDED_G_RANK,D_RANK_FORM_ID,G_RANK_RESP,ADD_TO_STD_DATE,ADD_TO_STD_AUTHORIZED_BY,ADD_TO_STD_COM,REMOVE_FROM_STD_DATE,REMOVE_FROM_STD_AUTHORIZED_BY,REMOVE_FROM_STD_COM,G_IMAGE_AVAILABLE_IND,G_IMAGE_NOTES,G_ELEMENT_INTERNAL_NOTES,REC_LAST_MOD_DATE,REC_LAST_MOD_USER,REC_CREATE_DATE,REC_CREATE_USER,ELEMENT_GLOBAL_SEQ_UID,ELEMENT_GLOBAL_OU_UID,D_MAINTAINED_BY_STATUS_ID,PENDING_IND,PARENT_ID,CLASSIFICATION_CD,G_CONFIDENCE_COM,CONCATENATED_CD,IN_PROGRESS_IND,DX_LAST_RECEIVED_DATE,DX_LAST_RECEIVED_STATUS,DX_LAST_EXCHANGE_ID
  from biotics_del.ELEMENT_GLOBAL_del
  where biotics_del.ELEMENT_GLOBAL_del.ELEMENT_GLOBAL_id= &v_egt_id;

Insert into biotics_user.TAXON_GLOBAL
   (ELEMENT_GLOBAL_ID,INTCODE_BCD,D_HYBRID_ID,TAXON_STAT_BCD,ELEMENT_SEQUENCE_NUM,D_JURIS_ENDEM_ID,EX_SITU_IND,EX_SITU_INSTITUTION,G_HYBRID_IND,DOMESTICATED_ORIGIN_IND,D_USESA_ID,USESA_DATE,INTERPRETED_USESA,INTERPRETED_USESA_DATE,USESA_COM,D_FWS_REGION_ID,D_CITES_ID,INTERPRETED_CITES,CITES_APPENDIX_III_COUNTRY,D_IUCN_ID,INTERPRETED_IUCN,GENERAL_STATUS_COM,REC_LAST_MOD_DATE,REC_LAST_MOD_USER,REC_CREATE_DATE,REC_CREATE_USER,D_STAKEHOLDER_SPECIES_ID,PARENT_SPECIES_ID)
 select ELEMENT_GLOBAL_ID,INTCODE_BCD,D_HYBRID_ID,TAXON_STAT_BCD,ELEMENT_SEQUENCE_NUM,D_JURIS_ENDEM_ID,EX_SITU_IND,EX_SITU_INSTITUTION,G_HYBRID_IND,DOMESTICATED_ORIGIN_IND,D_USESA_ID,USESA_DATE,INTERPRETED_USESA,INTERPRETED_USESA_DATE,USESA_COM,D_FWS_REGION_ID,D_CITES_ID,INTERPRETED_CITES,CITES_APPENDIX_III_COUNTRY,D_IUCN_ID,INTERPRETED_IUCN,GENERAL_STATUS_COM,REC_LAST_MOD_DATE,REC_LAST_MOD_USER,REC_CREATE_DATE,REC_CREATE_USER,D_STAKEHOLDER_SPECIES_ID,PARENT_SPECIES_ID
 from biotics_del.TAXON_GLOBAL_del
 where biotics_del.TAXON_GLOBAL_del.ELEMENT_GLOBAL_id= &v_egt_id;

delete from biotics_del.ELEMENT_GLOBAL_DEL WHERE element_global_id=&v_egt_id;
delete from biotics_del.TAXON_GLOBAL_DEL WHERE element_global_id=&v_egt_id;
  
spool off;

set verify on
set echo on