/* restore accidentally deleted EST */  
/* NOTE this just deletes the skeletal EST record, not all child tables */
/* See script attached to https://bioticssupport.natureserve.org/a/solutions/articles/201154-restore-a-record-from-the-deleted-schema for scripts necessary to recover child tables*/

accept path char prompt 'Enter path in which to save log file, w/o last back slash): ' 
accept v_est_id number prompt ' What is the EST_ID of the Element you wish to Undelete?';
spool '&path\UndeleteESTID_&v_est_id.log'

set verify off
set echo off

--2. run insert statements 
Insert into biotics_user.ELEMENT_SUBNATIONAL
   (ELEMENT_SUBNATIONAL_ID, ELEMENT_NATIONAL_ID, SUBNATION_ID, SNAME_ID, S_PRIMARY_COMMON_NAME, ACCEPTED_BY_ECOLOGY_IND, S_RANK, ROUNDED_S_RANK, S_DISTRIBUTION_COM, S_IMAGE_AVAILABLE_IND, D_MAINTAINED_BY_STATUS_ID, REC_LAST_MOD_DATE, REC_LAST_MOD_USER, REC_CREATE_DATE, REC_CREATE_USER, ELEMENT_SUBNATIONAL_SEQ_UID, ELEMENT_SUBNATIONAL_OU_UID, IN_PROGRESS_IND,D_DATA_SENSITIVE_ID)
  select ELEMENT_SUBNATIONAL_ID, ELEMENT_NATIONAL_ID, SUBNATION_ID, SNAME_ID, S_PRIMARY_COMMON_NAME, ACCEPTED_BY_ECOLOGY_IND, S_RANK, ROUNDED_S_RANK, S_DISTRIBUTION_COM, S_IMAGE_AVAILABLE_IND, D_MAINTAINED_BY_STATUS_ID, REC_LAST_MOD_DATE, REC_LAST_MOD_USER, REC_CREATE_DATE, REC_CREATE_USER, ELEMENT_SUBNATIONAL_SEQ_UID, ELEMENT_SUBNATIONAL_OU_UID, IN_PROGRESS_IND,'2' 
  from biotics_del.element_subnational_del
  where biotics_del.element_subnational_del.element_subnational_id= &v_est_id;

Insert into biotics_user.TAXON_SUBNATIONAL
   (ELEMENT_SUBNATIONAL_ID, HYBRID_IND, PEST_IND, REC_LAST_MOD_DATE, REC_LAST_MOD_USER, REC_CREATE_DATE, REC_CREATE_USER, DDF)
 select ELEMENT_SUBNATIONAL_ID, HYBRID_IND, PEST_IND, REC_LAST_MOD_DATE, REC_LAST_MOD_USER, REC_CREATE_DATE, REC_CREATE_USER, DDF
 from biotics_del.taxon_subnational_del
 where biotics_del.taxon_subnational_del.element_subnational_id= &v_est_id;

Insert into biotics_user.EL_SUBNATL_AGENCY_STATUS
   (EL_SUBNATL_AGENCY_STATUS_ID, ELEMENT_SUBNATIONAL_ID, AGENCY_NAME, AGENCY_STATUS, AGENCY_STATUS_DATE, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE, REC_CREATE_USER, DISPLAY_ORDER)
 select EL_SUBNATL_AGENCY_STATUS_ID, ELEMENT_SUBNATIONAL_ID, AGENCY_NAME, AGENCY_STATUS, AGENCY_STATUS_DATE,REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE, REC_CREATE_USER, DISPLAY_ORDER
 from biotics_del.el_subnatl_agency_status_del
 where biotics_del.el_subnatl_agency_status_del.element_subnational_id= &v_est_id;


--3. delete records from deleted schema 
delete from BIOTICS_DEL.EL_SUBNATL_AGENCY_STATUS_DEL WHERE element_subnational_id= &v_est_id;
delete from BIOTICS_DEL.TAXON_SUBNATIONAL_DEL WHERE element_subnational_id= &v_est_id;
delete from BIOTICS_DEL.ELEMENT_SUBNATIONAL_DEL WHERE element_subnational_id= &v_est_id;

spool off;

set verify on
set echo on