-- Purpose: To undelete a EO from deleted_Schema
-- dalbert 07012003 created
-- smoslin 10172002 added eo_id varible and eo_observation
-- Still to do
-- Create script to remove undeleted data from biotics_del

accept path char prompt 'enter path in which to save log file, w/o last back slash): ' 
accept v_eo_id char prompt ' What is the EO_ID of the EO you wish to Undelete?';
spool '&path\UndeleteEOID_&v_eo_id.log'

set verify off
set echo off

select shape_id,source_feature_descriptor from biotics_del.source_feature_del where shape_id in 
(select a.source_feature_shape_id from biotics_del.eo_source_feature_del a,biotics_del.eo_del b
              where a.eo_shape_id = b.shape_id and b.eo_id = &v_eo_id);

accept v_dump_val char prompt 'These sources will be undeleted. Do you want to continue? (Cntl-C to exit, Enter to Continue)';

-- EO shape record
insert into biotics_user.shape
(SHAPE_ID, FEATURE_CODE, SHAPE_TYPE, HAS_SHAPE_IND, DIGITAL_MAPPING_BY, 
 DIGITAL_MAPPING_DATE,  MAP_QC_BY, QC_COM, DELETED_IND, REC_CREATE_DATE, REC_CREATE_USER, 
 REC_LAST_MOD_DATE, REC_LAST_MOD_USER, SHAPE_SEQ_UID, MAP_QC_STATUS, SHAPE_OU_UID, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID) 
select 
SHAPE_ID, FEATURE_CODE, SHAPE_TYPE, 'N', DIGITAL_MAPPING_BY, 
 DIGITAL_MAPPING_DATE,  MAP_QC_BY, QC_COM, DELETED_IND, REC_CREATE_DATE, REC_CREATE_USER, 
 REC_LAST_MOD_DATE, REC_LAST_MOD_USER, SHAPE_SEQ_UID, MAP_QC_STATUS, SHAPE_OU_UID, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID
from biotics_del.shape_del
where biotics_del.shape_del.shape_id =
         (select shape_id from biotics_del.eo_del where eo_id = &v_eo_id);

-- EO source shape record(s)
insert into biotics_user.shape
(SHAPE_ID, FEATURE_CODE, SHAPE_TYPE, HAS_SHAPE_IND, DIGITAL_MAPPING_BY, 
 DIGITAL_MAPPING_DATE,  MAP_QC_BY, QC_COM, DELETED_IND, REC_CREATE_DATE, REC_CREATE_USER, 
 REC_LAST_MOD_DATE, REC_LAST_MOD_USER, SHAPE_SEQ_UID, MAP_QC_STATUS, SHAPE_OU_UID, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID) 
select 
SHAPE_ID, FEATURE_CODE, SHAPE_TYPE, 'N', DIGITAL_MAPPING_BY, 
 DIGITAL_MAPPING_DATE,  MAP_QC_BY, QC_COM, DELETED_IND, REC_CREATE_DATE, REC_CREATE_USER, 
 REC_LAST_MOD_DATE, REC_LAST_MOD_USER, SHAPE_SEQ_UID, MAP_QC_STATUS, SHAPE_OU_UID, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID
from biotics_del.shape_del
where biotics_del.shape_del.shape_id in
   (select a.source_feature_shape_id from biotics_del.eo_source_feature_del a,biotics_del.eo_del b
              where a.eo_shape_id = b.shape_id and b.eo_id = &v_eo_id);

-- Source Feature row(s) should be same as source shapes
insert into biotics_user.source_feature
(SOURCE_FEATURE_ID, ELEMENT_SUBNATIONAL_ID, SHAPE_ID, SOURCE_FEATURE_DESCRIPTOR , SOURCE_FEATURE_LOCATOR, 
 D_CONC_FEATURE_TYPE_ID, D_LOC_UNCERTAINTY_TYPE_ID, LOC_UNCERTAINTY_DISTANCE, LOC_UNCERTAINTY_UNIT_ID, 
 D_LOCATION_USE_CLASS_ID, INDEPENDENT_SOURCE_FEATURE_IND,  D_DIGITIZING_BASE_ID,   DIGITIZING_COM, 
 MAPPING_COM,  OBS_FEATURE_AREA, OBS_FEATURE_AREA_UNIT_ID, OBS_FEATURE_LENGTH, OBS_FEATURE_LENGTH_UNIT_ID, 
 D_DATA_QC_STATUS_ID, DATA_QC_BY, REC_CREATE_DATE, REC_CREATE_USER, REC_LAST_MOD_DATE, 
 REC_LAST_MOD_USER,  SOURCE_FEATURE_OU_UID, SOURCE_FEATURE_SEQ_UID, D_EST_REP_ACCURACY_ID, EST_REP_ACCURACY_COM, EXCLUDE_UNSUITABLE_HABITAT_IND, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID, DX_LAST_SUCCEEDED_DATE, D_DATA_SENSITIVE_ID, D_DATA_SENSITIVE_CATEGORY_ID, DATA_SENSITIVE_REASONS)  
select 
SOURCE_FEATURE_ID, ELEMENT_SUBNATIONAL_ID, SHAPE_ID, SOURCE_FEATURE_DESCRIPTOR , SOURCE_FEATURE_LOCATOR, 
 D_CONC_FEATURE_TYPE_ID, D_LOC_UNCERTAINTY_TYPE_ID, LOC_UNCERTAINTY_DISTANCE, LOC_UNCERTAINTY_UNIT_ID, 
 D_LOCATION_USE_CLASS_ID, INDEPENDENT_SOURCE_FEATURE_IND,  D_DIGITIZING_BASE_ID,   DIGITIZING_COM, 
 MAPPING_COM,  OBS_FEATURE_AREA, OBS_FEATURE_AREA_UNIT_ID, OBS_FEATURE_LENGTH, OBS_FEATURE_LENGTH_UNIT_ID, 
 D_DATA_QC_STATUS_ID, DATA_QC_BY, REC_CREATE_DATE, REC_CREATE_USER, REC_LAST_MOD_DATE, 
 REC_LAST_MOD_USER,  SOURCE_FEATURE_OU_UID, SOURCE_FEATURE_SEQ_UID, D_EST_REP_ACCURACY_ID, EST_REP_ACCURACY_COM, EXCLUDE_UNSUITABLE_HABITAT_IND, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID, DX_LAST_SUCCEEDED_DATE, D_DATA_SENSITIVE_ID, D_DATA_SENSITIVE_CATEGORY_ID, DATA_SENSITIVE_REASONS
from biotics_del.source_feature_del
where biotics_del.source_feature_del.shape_id in                          
(select a.source_feature_shape_id from biotics_del.eo_source_feature_del a,biotics_del.eo_del b
              where a.eo_shape_id = b.shape_id and b.eo_id = &v_eo_id);
              
              
-- Source feature visit(s)

insert into biotics_user.visit
(visit_id,source_feature_id,visited_by,visit_date,visit_notes, rec_last_mod_user,
rec_last_mod_date,rec_create_user,rec_create_date,display_order)
select
visit_id,source_feature_id,visited_by,visit_date,visit_notes, rec_last_mod_user,
rec_last_mod_date,rec_create_user,rec_create_date,display_order
from biotics_del.visit_del
where
 biotics_del.visit_del.source_feature_id in 
 (select a.source_feature_id from biotics_del.source_feature_del a,biotics_del.shape_del b,
 biotics_del.eo_source_feature_del c, biotics_del.eo_del d
 where a.shape_id = b.shape_id and b.shape_id = c.source_feature_shape_id and
 c.eo_shape_id = d.shape_id and d.eo_id = &v_eo_id);
 



-- EO Record
insert into biotics_user.eo
(EO_ID, ELEMENT_SUBNATIONAL_ID,  SHAPE_ID,  EO_NUM,  EO_NUM_BCD,  FIELD_OFFICE_NUM, D_ID_CONFIRMED_ID, DATA_SENSITIVE_REASONS,  PRECISION_BCD, LATITUDE, LONGITUDE, SOUTH,  NORTH,  EAST,  WEST,  D_EST_REP_ACCURACY_ID,  CALC_REP_ACCURACY,  REP_ACCURACY_COM,  SEPARATION_COM,  EO_REP_EDITED_IND,  EO_REP_EDITED_COM, D_CONFIDENCE_EXTENT_ID,  ADDITIONAL_INV_NEEDED_IND,  ADDITIONAL_INV_NEEDED_COM,  D_MJ_SPATIAL_REP_ID,  D_MULTI_JURISDICTIONAL_ID ,   MULTI_JURIS_COLLAB_COM,  SURVEY_DATE,  FIRST_OBS_DATE,  LAST_OBS_DATE,  EO_DATA,  MONITORING_NEEDS_COM,  RESEARCH_NEEDS_COM, CONDITION_OF_EO,  SIZE_OF_EO,  LANDSCAPE_CONTEXT,  D_BASIC_EO_RANK_ID,  D_ORIGIN_SUBRANK_ID,                                                                    
 EO_RANK_DATE, EO_RANK_COM,  EO_TYPE_BCD,  GEN_DESC, MIN_ELEV_FEET,  MIN_ELEV_METERS,  MAX_ELEV_FEET,  MAX_ELEV_METERS, OBS_AREA_ACRES,  OBS_AREA_HECTARES, EO_INTERPRETED_USESA_STATUS,  EO_INTERPRETED_COSEWIC_STATUS, D_MORE_LAND_ID, D_MORE_PROTECTION_ID,  D_TNC_INVOLVEMENT_ID,  PROTECTION_COM, D_MORE_MANAGEMENT_ID,  MGMT_COM, OWNER_COM, OWNERINFO_BCD, GENERAL_COM, D_BOUNDARIES_ID, IMAGE_IND,  CDREV_BCD, LEAD_RESP, VERSION_AUTHOR_NAME,  VERSION_DATE, TRANSCRIPTION_DATE, TRANSCRIBED_BY, MANUAL_FILE_NOTE,  PAPER_MAPPING_BY, PAPER_MAPPING_DATE, D_DATA_QC_STATUS_ID, DATA_QC_BY, REFERENCE_POINT_X, REFERENCE_POINT_Y, REC_LAST_MOD_DATE, REC_LAST_MOD_USER, REC_CREATE_DATE, REC_CREATE_USER, EO_SEQ_UID, PRINCIPAL_EO_SHAPE_ID, EO_OU_UID, EO_SPECS_VERSION_USED, EO_RANK_SPECS_VERSION_USED, D_IMPLEMENTATION_TIER_ID, EO_INTERPRETED_COSEWIC_ID, D_SEPARATION_DIST_TYPE_ID, SEPARATION_DIST_UNIT_ID, SEPARATION_DIST, NEW_EO_REASON, ADDITIONAL_TOPICS, DIRECTIONS, NS_EO_INTERP_USESA_STATUS, NS_EO_INTERP_COSEWIC_STATUS, EO_COSEWIC_ELEMENT_ID, EO_INTERPRETED_STATUS_COM, DO_NOT_EXCHANGE_IND, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID, DX_LAST_SUCCEEDED_DATE, D_DATA_SENSITIVE_ID, D_DATA_SENSITIVE_CATEGORY_ID)
 select 
 EO_ID ,  ELEMENT_SUBNATIONAL_ID,  SHAPE_ID,  EO_NUM,  EO_NUM_BCD,  FIELD_OFFICE_NUM, D_ID_CONFIRMED_ID, DATA_SENSITIVE_REASONS,  PRECISION_BCD, LATITUDE, LONGITUDE, SOUTH,  NORTH,  EAST,  WEST,  D_EST_REP_ACCURACY_ID,  CALC_REP_ACCURACY,  REP_ACCURACY_COM,  SEPARATION_COM,  EO_REP_EDITED_IND,  EO_REP_EDITED_COM, D_CONFIDENCE_EXTENT_ID,  ADDITIONAL_INV_NEEDED_IND,  ADDITIONAL_INV_NEEDED_COM,  D_MJ_SPATIAL_REP_ID,  D_MULTI_JURISDICTIONAL_ID ,   MULTI_JURIS_COLLAB_COM,  SURVEY_DATE,  FIRST_OBS_DATE,  LAST_OBS_DATE,  EO_DATA,  MONITORING_NEEDS_COM,  RESEARCH_NEEDS_COM, CONDITION_OF_EO,  SIZE_OF_EO,  LANDSCAPE_CONTEXT,  D_BASIC_EO_RANK_ID,  D_ORIGIN_SUBRANK_ID,                                                                    
 EO_RANK_DATE, EO_RANK_COM,  EO_TYPE_BCD,  GEN_DESC, MIN_ELEV_FEET,  MIN_ELEV_METERS,  MAX_ELEV_FEET,  MAX_ELEV_METERS, OBS_AREA_ACRES,  OBS_AREA_HECTARES, EO_INTERPRETED_USESA_STATUS,  EO_INTERPRETED_COSEWIC_STATUS, D_MORE_LAND_ID, D_MORE_PROTECTION_ID,  D_TNC_INVOLVEMENT_ID,  PROTECTION_COM, D_MORE_MANAGEMENT_ID,  MGMT_COM, OWNER_COM, OWNERINFO_BCD, GENERAL_COM, D_BOUNDARIES_ID, IMAGE_IND,  CDREV_BCD, LEAD_RESP, VERSION_AUTHOR_NAME,  VERSION_DATE, TRANSCRIPTION_DATE,  
 TRANSCRIBED_BY, MANUAL_FILE_NOTE,  PAPER_MAPPING_BY, PAPER_MAPPING_DATE, D_DATA_QC_STATUS_ID,  DATA_QC_BY, REFERENCE_POINT_X, REFERENCE_POINT_Y, REC_LAST_MOD_DATE, REC_LAST_MOD_USER,  REC_CREATE_DATE, REC_CREATE_USER, EO_SEQ_UID,  PRINCIPAL_EO_SHAPE_ID, EO_OU_UID, EO_SPECS_VERSION_USED, EO_RANK_SPECS_VERSION_USED, D_IMPLEMENTATION_TIER_ID, EO_INTERPRETED_COSEWIC_ID, D_SEPARATION_DIST_TYPE_ID, SEPARATION_DIST_UNIT_ID, SEPARATION_DIST, NEW_EO_REASON, ADDITIONAL_TOPICS, DIRECTIONS, NS_EO_INTERP_USESA_STATUS, NS_EO_INTERP_COSEWIC_STATUS, EO_COSEWIC_ELEMENT_ID, EO_INTERPRETED_STATUS_COM, DO_NOT_EXCHANGE_IND, DX_LAST_RECEIVED_DATE, DX_LAST_RECEIVED_STATUS, DX_LAST_EXCHANGE_ID, DX_LAST_SUCCEEDED_DATE, D_DATA_SENSITIVE_ID, D_DATA_SENSITIVE_CATEGORY_ID
from biotics_del.eo_del
where biotics_del.eo_del.shape_id =
            (select shape_id from biotics_del.eo_del where eo_id = &v_eo_id);  


-- The EO Source Feature Record(s)
insert into biotics_user.eo_source_feature
(EO_SOURCE_FEATURE_ID, EO_SHAPE_ID, EO_ID, SOURCE_FEATURE_ID, SOURCE_FEATURE_SHAPE_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, 
 REC_CREATE_DATE, REC_CREATE_USER, DISPLAY_ORDER)
select 
EO_SOURCE_FEATURE_ID, EO_SHAPE_ID, EO_ID, SOURCE_FEATURE_ID, SOURCE_FEATURE_SHAPE_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, 
 REC_CREATE_DATE, REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_source_feature_del
where biotics_del.eo_source_feature_del.eo_shape_id =
(select shape_id from biotics_del.eo_del where eo_id = &v_eo_id);    

insert into biotics_user.eo_owner
(EO_OWNER_ID, D_OWNER_TYPE_ID, EO_ID, OWNER_NAME, OWNER_NOTE, REC_LAST_MOD_USER,  REC_LAST_MOD_DATE,  REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_OWNER_ID, D_OWNER_TYPE_ID, EO_ID, OWNER_NAME, OWNER_NOTE, REC_LAST_MOD_USER,  REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_owner_del
where biotics_del.eo_owner_del.eo_id = &v_eo_id;

insert into biotics_user.eo_surveyor
(EO_SURVEYOR_ID, EO_ID, SURVEYOR, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_SURVEYOR_ID, EO_ID, SURVEYOR, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_surveyor_del
where biotics_del.eo_surveyor_del.eo_id = &v_eo_id;

insert into biotics_user.eo_site
(EO_SITE_ID, EO_ID, CONSERVATION_SITE_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER, AUTO_CALC_IND)
 select 
 EO_SITE_ID, EO_ID, CONSERVATION_SITE_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER, AUTO_CALC_IND
from biotics_del.eo_site_del
where biotics_del.eo_site_del.eo_id = &v_eo_id;

insert into biotics_user.eo_managed_area
(EO_MANAGED_AREA_ID, EO_ID, MANAGED_AREA_ID, D_CONTAINED_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER, AUTO_CALC_IND)
 select 
 EO_MANAGED_AREA_ID, EO_ID, MANAGED_AREA_ID, D_CONTAINED_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER, AUTO_CALC_IND
from biotics_del.eo_managed_area_del
where biotics_del.eo_managed_area_del.eo_id = &v_eo_id;

insert into biotics_user.eo_contact
(EO_CONTACT_ID, CONTACT_ID, EO_ID, EO_CONTACT_NOTE, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_CONTACT_ID, CONTACT_ID, EO_ID, EO_CONTACT_NOTE, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_contact_del
where biotics_del.eo_contact_del.eo_id = &v_eo_id;

insert into biotics_user.eo_reference
(EO_REFERENCE_ID, REFERENCE_ID, EO_ID, EO_REFERENCE_PRIMARY_IND, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_REFERENCE_ID, REFERENCE_ID, EO_ID, EO_REFERENCE_PRIMARY_IND, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_reference_del
where biotics_del.eo_reference_del.eo_id = &v_eo_id;

insert into biotics_user.eo_survey_type
(EO_SURVEY_TYPE_ID, D_SURVEY_TYPE_ID, EO_ID, EO_SURVEY_NOTE, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_SURVEY_TYPE_ID, D_SURVEY_TYPE_ID, EO_ID, EO_SURVEY_NOTE, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_survey_type_del
where biotics_del.eo_survey_type_del.eo_id = &v_eo_id;

insert into biotics_user.eo_keyword
(EO_KEYWORD_ID, D_EO_KEYWORD_ID, EO_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_KEYWORD_ID, D_EO_KEYWORD_ID, EO_ID, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_keyword_del
where biotics_del.eo_keyword_del.eo_id = &v_eo_id;

insert into biotics_user.eo_survey_site
(EO_SURVEY_SITE_ID, EO_ID, SURVEY_SITE_NAME, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_SURVEY_SITE_ID, EO_ID, SURVEY_SITE_NAME, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_survey_site_del
where biotics_del.eo_survey_site_del.eo_id = &v_eo_id;

insert into biotics_user.eo_specimen
(EO_SPECIMEN_ID, EO_ID, SPECIMEN_DESC, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER)
 select 
 EO_SPECIMEN_ID, EO_ID, SPECIMEN_DESC, REC_LAST_MOD_USER, REC_LAST_MOD_DATE, REC_CREATE_DATE,
 REC_CREATE_USER, DISPLAY_ORDER
from biotics_del.eo_specimen_del
where biotics_del.eo_specimen_del.eo_id = &v_eo_id;

spool off;

set verify on
set echo on




